## python3.5 3.5.3

=== debian/changelog ===
python3.5 (3.5.3-1+deb9u4) stretch-security; urgency=medium

  * Non-maintainer upload by the LTS Security Team.
  * CVE-2021-23336: only use '&' as a query string separator
  * CVE-2021-3426: remove the pydoc getfile feature
  * CVE-2021-3177: replace snprintf with Python unicode

 -- Anton Gladky <gladk@debian.org>  Mon, 05 Apr 2021 11:00:41 +0200

python3.5 (3.5.3-1+deb9u3) stretch-security; urgency=high

  * Non-maintainer upload by the LTS Team.

  [ Thorsten Alteholz ]
  * CVE-2019-20907: In Lib/tarfile.py, an attacker is able to craft a TAR
    archive leading to an infinite loop when opened by tarfile.open, because
    _proc_pax lacks header validation
  * CVE-2020-26116: http.client allows CRLF injection if the attacker controls
    the HTTP request method

  [ Roberto C. Sánchez ]
  * Update expired SSL certificates in unit test suite.

 -- Roberto C. Sánchez <roberto@debian.org>  Wed, 18 Nov 2020 16:09:16 -0500

python3.5 (3.5.3-1+deb9u2) stretch-security; urgency=high

  * Non-maintainer upload by the LTS Security Team.
  * CVE-2018-20406: Modules/_pickle.c has an integer overflow via a large
    LONG_BINPUT value that is mishandled during a "resize to twice the
    size" attempt. This issue might cause memory exhaustion, but is only
    relevant if the pickle format is used for serializing tens or hundreds
    of gigabytes of data.
  * CVE-2018-20852: http.cookiejar.DefaultPolicy.domain_return_ok in
    Lib/http/cookiejar.py does not correctly validate the domain: it can
    be tricked into sending existing cookies to the wrong server. An
    attacker may abuse this flaw by using a server with a hostname that
    has another valid hostname as a suffix (e.g., pythonicexample.com to
    steal cookies for example.com). When a program uses
    http.cookiejar.DefaultPolicy and tries to do an HTTP connection to an
    attacker-controlled server, existing cookies can be leaked to the
    attacker.
  * Update test_ssl.py with newer certificate and openssl version handling
  * CVE-2019-5010: an exploitable denial-of-service vulnerability exists
    in the X509 certificate parser. A specially crafted X509 certificate
    can cause a NULL pointer dereference, resulting in a denial of
    service. An attacker can initiate or accept TLS connections using
    crafted certificates to trigger this vulnerability.
  * CVE-2019-9636: Improper Handling of Unicode Encoding (with an
    incorrect netloc) during NFKC normalization. The impact is:
    Information disclosure (credentials, cookies, etc. that are cached
    against a given hostname). The components are: urllib.parse.urlsplit,
    urllib.parse.urlparse. The attack vector is: A specially crafted URL
    could be incorrectly parsed to locate cookies or authentication data
    and send that information to a different host than when parsed
    correctly.
  * Fix functional regression introduced by CVE-2019-9636 fix, which in
    turn introduces CVE-2019-10160
  * CVE-2019-10160: a security regression was discovered in python, which
    still allows an attacker to exploit CVE-2019-9636 by abusing the user
    and password parts of a URL. When an application parses user-supplied
    URLs to store cookies, authentication credentials, or other kind of
    information, it is possible for an attacker to provide specially
    crafted URLs to make the application locate host-related information
    (e.g. cookies, authentication data) and send them to a different host
    than where it should, unlike if the URLs had been correctly
    parsed. The result of an attack may vary based on the application.
  * CVE-2019-9740: an issue was discovered in urllib2. CRLF injection is
    possible if the attacker controls a url parameter, as demonstrated by
    the first argument to urllib.request.urlopen with \r\n (specifically
    in the query string after a ? character) followed by an HTTP header or
    a Redis command.
  * CVE-2019-9947: an issue was discovered in urllib2. CRLF injection is
    possible if the attacker controls a url parameter, as demonstrated by
    the first argument to urllib.request.urlopen with \r\n (specifically
    in the path component of a URL that lacks a ? character) followed by
    an HTTP header or a Redis command. This is similar to the
    CVE-2019-9740 query string issue.
  * CVE-2019-18348: an issue was discovered in urllib2. CRLF injection is
    possible if the attacker controls a url parameter, as demonstrated by
    the first argument to urllib.request.urlopen with \r\n (specifically
    in the host component of a URL) followed by an HTTP header. This is
    similar to the CVE-2019-9740 query string issue and the CVE-2019-9947
    path string issue
  * CVE-2019-9948: urllib supports the local_file: scheme, which makes it
    easier for remote attackers to bypass protection mechanisms that
    blacklist file: URIs, as demonstrated by triggering a
    urllib.urlopen('local_file:///etc/passwd') call.
  * CVE-2019-16935: The documentation XML-RPC server has XSS via the
    server_title field. This occurs in Lib/xmlrpc/server.py. If
    set_server_title is called with untrusted input, arbitrary JavaScript
    can be delivered to clients that visit the http URL for this server.
  * CVE-2019-16056: the email module wrongly parses email addresses that
    contain multiple @ characters. An application that uses the email
    module and implements some kind of checks on the From/To headers of a
    message could be tricked into accepting an email address that should
    be denied. An attack may be the same as in CVE-2019-11340; however,
    this CVE applies to Python more generally.
  * CVE-2020-8492: Python allows an HTTP server to conduct Regular
    Expression Denial of Service (ReDoS) attacks against a client because
    of urllib.request.AbstractBasicAuthHandler catastrophic backtracking.

 -- Sylvain Beucler <beuc@debian.org>  Thu, 09 Jul 2020 15:00:10 +0200

python3.5 (3.5.3-1+deb9u1) stretch-security; urgency=medium



=== debian/control ===
Source: python3.5
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.17.11),
  quilt, autoconf,
  lsb-release, sharutils,
  libreadline-dev, libncursesw5-dev (>= 5.3), 
  zlib1g-dev, libbz2-dev, liblzma-dev,
  libgdbm-dev, libdb-dev,
  tk-dev, blt-dev (>= 2.4z), libssl-dev,
  libexpat1-dev, libmpdec-dev (>= 2.4),
  libbluetooth-dev [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  locales [!armel !avr32 !hppa !ia64 !mipsel],
  libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k !avr32],
  libgpm2 [!hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  mime-support, netbase, bzip2, time, python3:any,
  net-tools, xvfb, xauth
Build-Depends-Indep: python3-sphinx
Standards-Version: 3.9.8
Vcs-Browser: https://code.launchpad.net/~doko/python/pkg3.5-debian
Vcs-Bzr: http://bazaar.launchpad.net/~doko/python/pkg3.5-debian
XS-Testsuite: autopkgtest

Package: python3.5
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.5-minimal (= ${binary:Version}), libpython3.5-stdlib (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
Suggests: python3.5-venv, python3.5-doc, binutils
Description: Interactive high-level object-oriented language (version 3.5)
 Python is a high-level, interactive, object-oriented language. Its 3.5 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: python3.5-venv
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.5 (= ${binary:Version}),
 python-pip-whl (>= 8.1.0-2), ${shlibs:Depends}, ${misc:Depends},
Breaks: python3-pip (<< 1.5.6-4)
Description: Interactive high-level object-oriented language (pyvenv binary, version 3.5)
 Python is a high-level, interactive, object-oriented language. Its 3.5 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the pyvenv-3.5 binary.

Package: libpython3.5-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.5-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
Breaks: libmpdec2 (<< 2.4.2)
Description: Interactive high-level object-oriented language (standard library, version 3.5)
 Python is a high-level, interactive, object-oriented language. Its 3.5 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains Python 3.5's standard library. It is normally not
 used on its own, but as a dependency of python3.5.

Package: python3.5-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: ${shlibs:Pre-Depends}
Depends: libpython3.5-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.5
Suggests: binfmt-support
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.5)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python3.5-minimal/README.Debian for a list of the modules
 contained in this package.

Package: libpython3.5-minimal
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libpython3.5-stdlib
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.5)
 This package contains some essential modules. It is normally not
 used on it's own, but as a dependency of python3.5-minimal.

Package: libpython3.5
Architecture: any
Multi-Arch: same
Section: libs
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.5-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Shared Python runtime library (version 3.5)
 Python is a high-level, interactive, object-oriented language. Its 3.5 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python3.5-examples
Architecture: all
Multi-Arch: foreign
Depends: python3.5:any (>= ${source:Version}), ${misc:Depends}
Description: Examples for the Python language (v3.5)
 Examples, Demos and Tools for Python (v3.5). These are files included in
 the upstream Python distribution (v3.5).

Package: python3.5-dev
Architecture: any
Multi-Arch: allowed
Depends: python3.5 (= ${binary:Version}), libpython3.5-dev (= ${binary:Version}), libpython3.5 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.5)
 Header files, a static library and development tools for building
 Python (v3.5) modules, extending the Python interpreter or embedding
 Python (v3.5) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: libpython3.5-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.5-stdlib (= ${binary:Version}), libpython3.5 (= ${binary:Version}), libexpat1-dev, ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.5)
 Header files, a static library and development tools for building
 Python (v3.5) modules, extending the Python interpreter or embedding
 Python (v3.5) in applications.
 .
 Maintainers of Python packages should read README.maintainers.
 .
 This package contains development files. It is normally not
 used on it's own, but as a dependency of python3.5-dev.

Package: libpython3.5-testsuite
Section: libdevel
Architecture: all
Depends: python3.5 (>= ${binary:Version}), ${misc:Depends}, net-tools
Suggests: python3-gdbm, python3-tk
Description: Testsuite for the Python standard library (v3.5)
 The complete testsuite for the Python standard library.  Note that
 a subset is found in the libpython3.5-stdlib package, which should
 be enough for other packages to use (please do not build-depend
 on this package, but file a bug report to include additional 
 testsuite files in the libpython3.5-stdlib package).

Package: idle-python3.5
Architecture: all
Depends: python3.5, python3-tk, python3.5-tk, ${misc:Depends}
Enhances: python3.5
Description: IDE for Python (v3.5) using Tkinter
 IDLE is an Integrated Development Environment for Python (v3.5).
 IDLE is written using Tkinter and therefore quite platform-independent.

Package: python3.5-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}
Suggests: python3.5
Description: Documentation for the high-level object-oriented language Python (v3.5)
 These is the official set of documentation for the interactive high-level
 object-oriented language Python (v3.5). All documents are provided
 in HTML format. The package consists of ten documents:
 .
   * What's New in Python3.5
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules

Package: python3.5-dbg
Section: debug
Architecture: any
Multi-Arch: allowed
Priority: extra
Depends: python3.5 (= ${binary:Version}), libpython3.5-dbg (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gdb
Suggests: python3-gdbm-dbg, python3-tk-dbg
Description: Debug Build of the Python Interpreter (version 3.5)
 The package holds two things:
 .
 - A Python interpreter configured with --pydebug. Dynamically loaded modules
   are searched as <foo>_d.so first. Third party extensions need a separate
   build to be used by this interpreter.
 - Debug information for standard python interpreter and extensions.
 .
 See the README.debug for more information.

Package: libpython3.5-dbg
Section: debug
Architecture: any
Multi-Arch: same
Priority: extra
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.5-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Debug Build of the Python Interpreter (version 3.5)
 The package holds two things:
 .
 - Extensions for a Python interpreter configured with --pydebug.
 - Debug information for standard python extensions.
 .
 See the README.debug for more information.

=== debian/rules ===
#!/usr/bin/make -f

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS LDFLAGS CPPFLAGS

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

vafilt		= $(subst $(2)=,,$(filter $(2)=%,$(1)))
DPKG_VARS	:= $(shell dpkg-architecture)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_ENDIAN	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

CHANGELOG_VARS := $(shell dpkg-parsechangelog | \
	sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE  := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)

LAST_CHANGE := $(shell dpkg-parsechangelog -S Date)
export BUILD_DATE := $(shell LC_ALL=C date -u +'%b %e %Y' -d '$(LAST_CHANGE)')
export BUILD_TIME := $(shell LC_ALL=C date -u +'%H:%M:%S' -d '$(LAST_CHANGE)')

SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
export SPHINXOPTS

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)

dh_compat2 := $(shell dpkg --compare-versions "$$(dpkg-query -f '$${Version}' -W debhelper)" lt 9.20150811ubuntu2 && echo DH_COMPAT=2)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_CHECK := yes
  endif
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_BENCH := yes
    WITHOUT_STONE := yes
  endif
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  WITHOUT_BENCH := yes
  WITHOUT_CHECK := yes
  WITHOUT_STONE := yes
endif
  WITHOUT_CHECK := yes
  WITHOUT_BENCH := yes

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
distrelease  := $(shell lsb_release -cs)

VER=3.5
SVER=3.5.0~b1
NVER=3.6
PVER=python$(VER)
EXT_VER=$(subst .,,$(VER))
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = no
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := no
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  PY_PRIO = standard
  #PYSTDDEP = , python (>= $(VER))
else
  PY_PRIO = optional
endif
ifeq ($(distribution),Ubuntu)
  PY_MINPRIO = required
  PY_MINPRIO = optional
  with_fpectl = yes
  #with_udeb = yes
else
  PY_MINPRIO = $(PY_PRIO)
  with_fpectl = yes
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  bd_qual = :any
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  ma_filter = cat
else
  ma_filter = grep -v '^Multi-Arch:'
endif
ifneq (,$(filter $(distrelease),sid stretch experimental))
  bd_gcc = gcc (>= 4:6.3),
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_dpkgdev = dpkg-dev (>= 1.17.11),
endif

CC=$(DEB_HOST_GNU_TYPE)-gcc
CXX=$(DEB_HOST_GNU_TYPE)-g++

AR=$(DEB_HOST_GNU_TYPE)-ar
RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib

DPKG_CPPFLAGS:= $(shell dpkg-buildflags --get CPPFLAGS)
DPKG_CFLAGS  := $(shell dpkg-buildflags --get CFLAGS)
DPKG_LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(patsubst -O%,-Og,$(DPKG_CFLAGS))

# on alpha, use -O2 only, use -mieee
ifeq ($(DEB_HOST_ARCH),alpha)
    OPT_CFLAGS += -mieee
    DEBUG_CFLAGS += -mieee
    EXTRA_OPT_FLAGS += -O2
endif
ifeq ($(DEB_HOST_ARCH),m68k)
    EXTRA_OPT_FLAGS += -O2
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
      with_pgo := yes
    endif
  endif
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf i386 powerpc ppc64 ppc64el s390x))
  with_lto := yes
endif

ifeq ($(distribution),Debian)
  # FIXME: https://buildd.debian.org/status/logs.php?pkg=python3.5&ver=3.5.1-1&arch=s390x&suite=sid
  with_lto := $(if $(filter $(DEB_HOST_ARCH), s390x),,$(with_lto))
endif

ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
    OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS))
    EXTRA_OPT_CFLAGS = -O0
    with_pgo =
    with_lto =
endif

ifeq ($(with_lto),yes)
    LTO_CFLAGS = -g -flto -fuse-linker-plugin
    with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
			| sed -n '/^$(CC)/s,.* ,,p') ge 4.9 && echo yes)
    ifeq ($(with_fat_lto),yes)
      LTO_CFLAGS += -ffat-lto-objects
    endif
    EXTRA_OPT_CFLAGS += $(LTO_CFLAGS)
    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
endif

make_build_target = $(if $(with_pgo),profile-opt)

buildd_static	:= $(CURDIR)/build-static
buildd_shared	:= $(CURDIR)/build-shared
buildd_debug	:= $(CURDIR)/build-debug
buildd_shdebug	:= $(CURDIR)/build-shdebug

d		:= debian/tmp
scriptdir	=  usr/share/lib/python$(VER)
scriptdir	=  usr/share/python$(VER)
scriptdir	=  usr/lib/python$(VER)

# package names and directories
p_base	:= $(PVER)
p_min	:= $(PVER)-minimal
p_lib	:= lib$(PVER)
p_tk	:= $(PVER)-tk
p_dev	:= $(PVER)-dev
p_exam	:= $(PVER)-examples
p_idle	:= idle-$(PVER)
p_doc	:= $(PVER)-doc
p_dbg	:= $(PVER)-dbg
p_udeb	:= $(PVER)-udeb
p_venv	:= $(PVER)-venv

p_lbase	:= lib$(PVER)-stdlib
p_lmin	:= lib$(PVER)-minimal
p_ldev	:= lib$(PVER)-dev
p_ldbg	:= lib$(PVER)-dbg
p_ltst	:= lib$(PVER)-testsuite

d_base	:= debian/$(p_base)
d_min	:= debian/$(p_min)
d_lib	:= debian/$(p_lib)
d_tk	:= debian/$(p_tk)
d_dev	:= debian/$(p_dev)
d_exam	:= debian/$(p_exam)
d_idle	:= debian/$(p_idle)
d_doc	:= debian/$(p_doc)
d_dbg	:= debian/$(p_dbg)
d_udeb	:= debian/$(p_udeb)
d_venv	:= debian/$(p_venv)

d_lbase	:= debian/$(p_lbase)
d_lmin	:= debian/$(p_lmin)
d_ldev	:= debian/$(p_ldev)
d_ldbg	:= debian/$(p_ldbg)
d_ltst	:= debian/$(p_ltst)

build-arch: stamps/stamp-build
build-indep: stamps/stamp-build-doc
build: build-arch
stamps/stamp-build: stamps/stamp-build-static stamps/stamp-mincheck \
    stamps/stamp-build-shared stamps/stamp-build-debug \
    stamps/stamp-build-shared-debug \
    stamps/stamp-check stamps/stamp-pystone stamps/stamp-pybench
	touch $@

PROFILE_EXCLUDES = test_compiler test_distutils test_subprocess \
	test_multiprocessing test_multiprocessing_fork \

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential, locales, python3.5-dev, libpython3.5-testsuite, python3-gdbm, python3.5-venv
# need to turn off apport
Restrictions: needs-root

Tests: testsuite-dbg
Depends: build-essential, locales, python3.5-dev, python3.5-dbg, libpython3.5-testsuite, python3-gdbm-dbg, gdb, python3.5-venv
# need to turn off apport
Restrictions: needs-root

Tests: failing-tests
Depends: build-essential, locales, python3.5-dev, libpython3.5-testsuite, python3-gdbm, python3.5-venv
# need to turn off apport
Restrictions: needs-root allow-stderr

Tests: failing-tests-dbg
Depends: build-essential, locales, python3.5-dev, python3.5-dbg, libpython3.5-testsuite, python3-gdbm-dbg, gdb, python3.5-venv
# need to turn off apport
Restrictions: needs-root allow-stderr

## python3.5 3.5.4

=== Doc/Makefile ===
#
# Makefile for Python documentation
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#

# You can set these variables from the command line.
PYTHON       = python3
SPHINXBUILD  = sphinx-build
BLURB = $(PYTHON) -m blurb
PAPER        =
SOURCES      =
DISTVERSION  = $(shell $(PYTHON) tools/extensions/patchlevel.py)

ALLSPHINXOPTS = -b $(BUILDER) -d build/doctrees -D latex_elements.papersize=$(PAPER) \
                $(SPHINXOPTS) . build/$(BUILDER) $(SOURCES)

.PHONY: help build html htmlhelp latex text changes linkcheck \
	suspicious coverage doctest pydoc-topics htmlview clean dist check serve \
	autobuild-dev autobuild-stable venv

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to remove build files"
	@echo "  venv       to create a venv with necessary tools"
	@echo "  html       to make standalone HTML files"
	@echo "  htmlview   to open the index page built by the html target in your browser"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  text       to make plain text files"
	@echo "  epub       to make EPUB files"
	@echo "  changes    to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  coverage   to check documentation coverage for library and C API"
	@echo "  doctest    to run doctests in the documentation"
	@echo "  pydoc-topics  to regenerate the pydoc topics file"
	@echo "  dist       to create a \"dist\" directory with archived docs for download"
	@echo "  suspicious to check for suspicious markup in output text"
	@echo "  check      to run a check for frequent markup errors"
	@echo "  serve      to serve the documentation on the localhost (8000)"

build:
	-mkdir -p build
# Look first for a Misc/NEWS file (building from a source release tarball
# or old repo) and use that, otherwise look for a Misc/NEWS.d directory
# (building from a newer repo) and use blurb to generate the NEWS file.
	@if [ -f  ../Misc/NEWS ] ; then \
		echo "Using existing Misc/NEWS file"; \
		cp ../Misc/NEWS build/NEWS; \
	elif [ -d ../Misc/NEWS.d ]; then \
		echo "Building NEWS from Misc/NEWS.d with blurb"; \
		$(BLURB) merge -f build/NEWS; \
	else \
		echo "Neither Misc/NEWS.d nor Misc/NEWS found; cannot build docs"; \
		exit 1; \
	fi
	$(SPHINXBUILD) $(ALLSPHINXOPTS)
	@echo

html: BUILDER = html
html: build
	@echo "Build finished. The HTML pages are in build/html."

htmlhelp: BUILDER = htmlhelp
htmlhelp: build
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      "build/htmlhelp/pydoc.hhp project file."

latex: BUILDER = latex
latex: build
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

text: BUILDER = text
text: build
	@echo "Build finished; the text files are in build/text."

epub: BUILDER = epub
epub: build
	@echo "Build finished; the epub files are in build/epub."

changes: BUILDER = changes
changes: build
	@echo "The overview file is in build/changes."

linkcheck: BUILDER = linkcheck
linkcheck:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Link check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/output.txt"; \
	false; }

suspicious: BUILDER = suspicious
suspicious:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Suspicious check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/suspicious.csv.  If all issues are false" \
	     "positives, append that file to tools/susp-ignored.csv."; \
	false; }

coverage: BUILDER = coverage
coverage: build
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

doctest: BUILDER = doctest
doctest:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Testing of doctests in the sources finished, look at the" \
	     "results in build/doctest/output.txt"; \
	false; }

pydoc-topics: BUILDER = pydoc-topics
pydoc-topics: build
	@echo "Building finished; now run this:" \
	      "cp build/pydoc-topics/topics.py ../Lib/pydoc_data/topics.py"

htmlview: html
	 $(PYTHON) -c "import webbrowser; webbrowser.open('build/html/index.html')"

clean:
	-rm -rf build/* venv/*

venv:
	$(PYTHON) -m venv venv
	./venv/bin/python3 -m pip install -U Sphinx blurb

dist:
	rm -rf dist
	mkdir -p dist

	# archive the HTML
	make html
	cp -pPR build/html dist/python-$(DISTVERSION)-docs-html
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-html.tar python-$(DISTVERSION)-docs-html
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-html.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-html.zip python-$(DISTVERSION)-docs-html)
	rm -r dist/python-$(DISTVERSION)-docs-html
	rm dist/python-$(DISTVERSION)-docs-html.tar

	# archive the text build
	make text
	cp -pPR build/text dist/python-$(DISTVERSION)-docs-text
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-text.tar python-$(DISTVERSION)-docs-text
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-text.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-text.zip python-$(DISTVERSION)-docs-text)
	rm -r dist/python-$(DISTVERSION)-docs-text
	rm dist/python-$(DISTVERSION)-docs-text.tar

	# archive the A4 latex
	rm -rf build/latex
	make latex PAPER=a4
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-a4.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-a4.tar.bz2

	# archive the letter latex
	rm -rf build/latex
	make latex PAPER=letter
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-letter.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-letter.tar.bz2

	# copy the epub build
	rm -rf build/epub
	make epub
	cp -pPR build/epub/Python.epub dist/python-$(DISTVERSION)-docs.epub

check:
	$(PYTHON) tools/rstlint.py -i tools

serve:
	../Tools/scripts/serve.py build/html

# Targets for daily automated doc build

# for development releases: always build
autobuild-dev:
	make dist SPHINXOPTS='$(SPHINXOPTS) -A daily=1 -A versionswitcher=1'
	-make suspicious

# for quick rebuilds (HTML only)
autobuild-dev-html:
	make html SPHINXOPTS='$(SPHINXOPTS) -A daily=1 -A versionswitcher=1'

# for stable releases: only build if not in pre-release stage (alpha, beta)
# release candidate downloads are okay, since the stable tree can be in that stage
autobuild-stable:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev

autobuild-stable-html:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev-html

=== debian/changelog ===
python3.5 (3.5.4-4) unstable; urgency=medium

  * Add package breaks for extensions referencing symbols for the removed
    _PyFPE module. Closes: #873921.

 -- Matthias Klose <doko@debian.org>  Tue, 05 Sep 2017 20:32:10 +0200

python3.5 (3.5.4-3) unstable; urgency=medium

  * Stop building the fpectl extension.
  * Break python3-numpy (<< 1:1.12.1-3.1), referencing the now missing fpectl
    modules. Addresses: #873791.

 -- Matthias Klose <doko@debian.org>  Thu, 31 Aug 2017 14:22:39 +0200

python3.5 (3.5.4-2) unstable; urgency=medium

  * Update breaks/replaces. Closes: #871579.

 -- Matthias Klose <doko@debian.org>  Sat, 12 Aug 2017 10:08:14 -0400

python3.5 (3.5.4-1) unstable; urgency=medium

  * Python 3.5.4 release.
  * Re-enable running the testsuite.

 -- Matthias Klose <doko@debian.org>  Tue, 08 Aug 2017 12:47:40 -0400

python3.5 (3.5.4~rc1-1) unstable; urgency=medium

  * Python 3.5.4 release candidate 1.
    - bpo-30500: Fix urllib.parse.splithost() to correctly parse fragments. For
      example, ``splithost('//127.0.0.1#@evil.com/')`` now correctly returns the
      ``127.0.0.1`` host, instead of treating ``@evil.com`` as the host in an
      authentification (``login@host``).
    - bpo-30876: Relative import from unloaded package now reimports the package
      instead of failing with SystemError.  Relative import from non-package now
      fails with ImportError rather than SystemError.
    - bpo-30765: Avoid blocking in pthread_mutex_lock() when
      PyThread_acquire_lock() is asked not to block.
    - bpo-29403: Fix ``unittest.mock``'s autospec to not fail on method-bound
      builtin functions.
    - bpo-30961: Fix decrementing a borrowed reference in tracemalloc.
    - bpo-30886: Fix multiprocessing.Queue.join_thread(): it now waits until the
      thread completes, even if the thread was started by the same process which
      created the queue.
    - bpo-29854: Fix segfault in readline when using readline's history-size
      option.
    - bpo-30807: signal.setitimer() may disable the timer when passed a tiny
      value.
      Tiny values (such as 1e-6) are valid non-zero values for setitimer(),
      which is specified as taking microsecond-resolution intervals. However, on
      some platform, our conversion routine could convert 1e-6 into a zero
      interval, therefore disabling the timer instead of (re-)scheduling it.
    - bpo-30441: Fix bug when modifying os.environ while iterating over it
    - bpo-30532: Fix email header value parser dropping folding white space in
      certain cases.
    - bpo-30879: os.listdir() and os.scandir() now emit bytes names when called
      with bytes- like argument.
    - bpo-30746: Prohibited the '=' character in environment variable names in
      ``os.putenv()`` and ``os.spawn*()``.
    - bpo-29755: Fixed the lgettext() family of functions in the gettext module.
      They now always return bytes.
    - bpo-30645: Fix path calculation in imp.load_package(), fixing it for cases
      when a package is only shipped with bytecodes.
    - bpo-23890: unittest.TestCase.assertRaises() now manually breaks a
      reference cycle to not keep objects alive longer than expected.
    - bpo-30149: inspect.signature() now supports callables with variable-
      argument parameters wrapped with partialmethod.
    - bpo-29931: Fixed comparison check for ipaddress.ip_interface objects.
    - bpo-24484: Avoid race condition in multiprocessing cleanup.
    - bpo-28994: The traceback no longer displayed for SystemExit raised in a
      callback registered by atexit.
    - bpo-30508: Don't log exceptions if Task/Future "cancel()" method was
      called.
    - bpo-28556: Updates to typing module: Add generic AsyncContextManager, add
      support for ContextManager on all versions.
    - bpo-29870: Fix ssl sockets leaks when connection is aborted in asyncio/ssl
      implementation.
    - bpo-29743: Closing transport during handshake process leaks open socket.
    - bpo-27585: Fix waiter cancellation in asyncio.Lock.
    - bpo-30418: On Windows, subprocess.Popen.communicate() now also ignore
      EINVAL on stdin.write() if the child process is still running but closed
      the pipe.
    - bpo-28969: Fixed race condition in C implementation of
      functools.lru_cache. KeyError could be raised when cached function with
      full cache was simultaneously called from differen threads with the same
      uncached arguments.
    - bpo-29142: In urllib.request, suffixes in no_proxy environment variable
      with leading dots could match related hostnames again (e.g. .b.c matches
      a.b.c).
    - bpo-30176: Add missing attribute related constants in curses
      documentation.
    - bpo-30822: Fix regrtest command line parser to allow passing -u
      extralargefile to run test_zipfile64.
    - bpo-30383: regrtest: Enhance regrtest and backport features from the
      master branch.
      Add options: --coverage, --testdir, --list-tests (list test files, don't
      run them), --list-cases (list test identifiers, don't run them,
      :issue:`30523`), --matchfile (load a list of test filters from a text
      file, :issue:`30540`), --slowest (alias to --slow).

      Enhance output: add timestamp, test result, currently running tests,
      "Tests result: xxx" summary with total duration, etc.

      Fix reference leak hunting in regrtest, --huntrleaks: regrtest now warms
      up caches, create explicitly all internal singletons which are created on
      demand to prevent false positives when checking for reference leaks.
      (:issue:`30675`).
    - bpo-30357: test_thread: setUp() now uses support.threading_setup() and
      support.threading_cleanup() to wait until threads complete to avoid random
      side effects on following tests.
    - bpo-28087: Skip test_asyncore and test_eintr poll failures on macOS. Skip
      some tests of select.poll when running on macOS due to unresolved issues


=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.17.11),
   quilt, autoconf,
   lsb-release, sharutils,
-  libreadline-dev, libncursesw5-dev (>= 5.3), 
+  libreadline-dev, libncursesw5-dev (>= 5.3), gcc (>= 4:6.3),
   zlib1g-dev, libbz2-dev, liblzma-dev,
   libgdbm-dev, libdb-dev,
   tk-dev, blt-dev (>= 2.4z), libssl-dev,
@@ -53,7 +53,8 @@
 Priority: optional
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libpython3.5-minimal (= ${binary:Version}), mime-support, ${shlibs:Depends}, ${misc:Depends}
-Breaks: libmpdec2 (<< 2.4.2)
+Breaks: libmpdec2 (<< 2.4.2), libpython3.5-testsuite (<< 3.5.4~rc1-1), cython3 (<< 0.26-2.1), python3-lxml (<< 3.8.0-2), python3-numpy (<< 1:1.12.1-3.1), python3-tk (<< 3.6.2-1~), python3-scipy (<< 0.18.1-2.1), borgbackup (<= 1.0.11-3), python3-acora (<= 2.0-2+b1), python3-adios (<= 1.12.0-3), python3-astroml-addons (<= 0.2.2-4), python3-astropy (<= 2.0.1-2), python3-astroscrappy (<= 1.0.5-1+b1), python3-asyncpg (<= 0.12.0-1), python3-bcolz (<= 1.1.0+ds1-4+b1), python3-brainstorm (<= 0.5-3+b1), python3-cartopy (<= 0.14.2+dfsg1-2+b1), python3-cutadapt (<= 1.13-1+b1), python3-djvu (<= 0.8-2), python3-fabio (<= 0.4.0+dfsg-2+b1), python3-falcon (<= 1.0.0-2+b1), python3-fiona (<= 1.7.9-1), python3-grib (<= 2.0.2-2), python3-gssapi (<= 1.2.0-1+b1), python3-h5py (<= 2.7.0-1+b1), python3-healpy (<= 1.10.3-2+b1), python3-kivy (<= 1.9.1-1+b1), python3-libdiscid (<= 1.0-1+b1), python3-liblo (<= 0.10.0-3+b1), python3-llfuse (<= 1.2+dfsg-1+b1), python3-ltfatpy (<= 1.0.9-1), python3-netcdf4 (<= 1.2.9-1+b1), python3-pandas-lib (<= 0.20.3-1), python3-petsc4py (<= 3.7.0-3+b1), python3-pybedtools (<= 0.7.8-1), python3-pyfai (<= 0.13.0+dfsg-1+b1), python3-pygpu (<= 0.6.9-2), python3-pymca5 (<= 5.1.3+dfsg-1+b1), python3-pymssql (<= 2.1.3+dfsg-1+b1), python3-pyresample (<= 1.5.0-3+b1), python3-pysam (<= 0.11.2.2+ds-3), python3-pywt (<= 0.5.1-1.1+b1), python3-rasterio (<= 0.36.0-2+b2), python3-sfml (<= 2.2~git20150611.196c88+dfsg-4), python3-shapely (<= 1.6.1-1), python3-skbio (<= 0.5.1-2+b1), python3-skimage-lib (<= 0.12.3-9+b1), python3-sklearn-lib (<= 0.19.0-1), python3-specutils (<= 0.2.2-1+b1), python3-stemmer (<= 1.3.0+dfsg-1+b7), python3-tables-lib (<= 3.3.0-5+b1), python3-tinycss (<= 0.4-1+b1), python3-wheezy.template (<= 0.1.167-1.1+b1), python3-yt (<= 3.3.3-2+b1), 
+Replaces: libpython3.5-testsuite (<< 3.5.4~rc1-1)
 Description: Interactive high-level object-oriented language (standard library, version 3.5)
  Python is a high-level, interactive, object-oriented language. Its 3.5 version
  includes an extensive class library with lots of goodies for

=== debian/rules ===
--- 
+++ 
@@ -56,8 +56,6 @@
   WITHOUT_CHECK := yes
   WITHOUT_STONE := yes
 endif
-  WITHOUT_CHECK := yes
-  WITHOUT_BENCH := yes
 
 COMMA = ,
 ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
@@ -66,6 +64,9 @@
 
 distribution := $(shell lsb_release -is)
 distrelease  := $(shell lsb_release -cs)
+derivative := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
+		elif dpkg-vendor --derives-from Debian; then echo Debian; \
+		else echo Unknown; fi)
 
 VER=3.5
 SVER=3.5.0~b1
@@ -112,11 +113,9 @@
 ifeq ($(distribution),Ubuntu)
   PY_MINPRIO = required
   PY_MINPRIO = optional
-  with_fpectl = yes
   #with_udeb = yes
 else
   PY_MINPRIO = $(PY_PRIO)
-  with_fpectl = yes
 endif
 ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
   bd_qual = :any
@@ -153,6 +152,10 @@
 endif
 ifeq ($(DEB_HOST_ARCH),m68k)
     EXTRA_OPT_FLAGS += -O2
+endif
+ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
+    OPT_CFLAGS += -fexceptions
+    DEBUG_CFLAGS += -fexceptions
 endif
 
 ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
@@ -246,8 +249,3 @@
 stamps/stamp-build: stamps/stamp-build-static stamps/stamp-mincheck \
     stamps/stamp-build-shared stamps/stamp-build-debug \
     stamps/stamp-build-shared-debug \
-    stamps/stamp-check stamps/stamp-pystone stamps/stamp-pybench
-	touch $@
-
-PROFILE_EXCLUDES = test_compiler test_distutils test_subprocess \
-	test_multiprocessing test_multiprocessing_fork \
